% This program uses a Genetic Algorithm for optimizing a Yagi Antenna. 
% It needs the subroutines ga.m, Yagi.m, nec_read.m, and nec2dx500.exe.
%Set up parameter space for the Genetic Algorithm.
parspace(:,1)=[.35; .55]; %Range of lengths for element #1; Reflector
parspace(:,2)=[.35; .55]; %Range of lengths for element #2; Driven
parspace(:,3)=[.35; .55]; %Range of lengths for element #3; Director
parspace(:,4)=[.15; .5];   %Range of spacings between element #1 and #2
parspace(:,5)=[.15; .5];   %Range of spacings between element #2 and #3
%Run the Genetic Algorithm.
param=ga('Yagi',parspace)
Lr=param(1); %length of reflector
Ls=param(2); %length of driven element
Ld=param(3); %length of director
Sr=-param(4); %locating of reflector
Sd=param(5);  %locating of director
%Display solution
disp('Optimized Solution')
disp(['Lr=',num2str(Lr),'   Ls=',num2str(Ls),'   Ld=',num2str(Ld)])
disp(['Sr=',num2str(Sr),'   Sd=',num2str(Sd)])
